var visiware = visiware || {},
	texts = [];

visiware.preload = {};
visiware.preload.Main = function(){
	/* Div contenant tout l'ecran de chargement. */
	this.div_all = undefined;
	/* Div contenant la barre de chargement. */
	this.bar_div = undefined;
	/* Image du logo. */
	this.logo = undefined;
	/* Image du logo du service. */
	this.service_logo = undefined;
	/* Barre de chargement. */
	this.bar_span = undefined;
	/* Texte de l'écran. */
	this.text = undefined;
	/* Chemin vers les ressources. */
	this.directory = "media/";//http://192.168.40.55/maksym/tenth_delivery_media/"; //Changer le chemin ici vers le serveur de rsc de dish
	//this.directory = "http://appf-stag.echostarapps.net:880/media/visiware/v1.7.3/"; //Changer le chemin ici vers le serveur de rsc de dish
	/* Langue */
	this.language = sessionStorage.language || "en_US";
	
	this.tmp_img = undefined;
	
	//Si l'url n'est pas relatif on concatene l'id du jeu comme sous répertoire pour l'url absolut.)
	if ( this.directory.charAt(0) !== "." ) {
		this.directory += visiware.info.gameId + "/img/";
	}
};

/* Fonction appelée par la page au chargement. */
visiware.preload.Main.prototype.start = function(){
	/* Ajoutez ici les textes des différentes langues. */
	texts.fr_FR = "Chargement en cours";
	texts.en_US = "Loading, please wait";
	
	/* Mise en place de l'écran. */
	visiware.preload.main.createDiv();
};

/* Met en place l'environnement de chargement. */
visiware.preload.Main.prototype.createDiv = function(){
	var self = this,
		dir = this.directory;
		
	dir += "rsc/pix/preload/" + this.language + "/";
	this.div_all = document.createElement("div");
	this.bar_div = document.createElement("div");
	this.logo = document.createElement("img");
	this.service_logo = document.createElement("img");
	this.bar_span = document.createElement("span");
	this.text = document.createElement("span");
	this.tmp_img = document.createElement("img");

	this.div_all.id = "loading-screen";
	this.bar_div.id = "loading-bar";
	this.logo.id = "loading-logo";
	this.service_logo.id = "loading-service-logo";
	this.text.id = "loading-text";

	this.div_all.appendChild( this.logo );
	this.div_all.appendChild( this.bar_div );
	this.bar_div.appendChild( this.bar_span );
	this.div_all.appendChild( this.text );
	this.div_all.appendChild( this.service_logo );

    this.logo.onerror = function() {
        console.log( "Image loading failed: " + self.logo.src );
    };
    this.service_logo.onerror = function() {
        console.log( "Image loading failed: " + self.service_logosrc );
    };
    this.bar_span.onerror = function() {
        console.log( "Image loading failed: " + self.bar_span.src );
    };

	this.logo.src = dir + "logo.png";
	this.service_logo.src = this.directory + "network/assets/preload/serviceLogo.png";
	this.bar_span.style.width = "0%";
	this.bar_span.style.backgroundImage = "url(" + dir + "bar.png)";

	this.text.innerHTML = texts[this.language] || "";

	document.body.appendChild( this.div_all );

	/* Pour l'image de fond on cree une image juste pour avoir l'event onload. */
	this.tmp_img = new Image();
	this.tmp_img.onload = function(){
		self.backgroundLoaded( self );
	};
    this.tmp_img.onerror = function(){
        console.log( "Image loading failed: " + self.tmp_img.src );
        self.backgroundLoaded( self );
    };
	
	this.tmp_img.src = dir + "wallpaper.jpg";
};

/* Quand l'image de fond est chargée on l'affiche et on lance le chargement du javascript. */
visiware.preload.Main.prototype.backgroundLoaded = function( _self ){
	_self.div_all.style.backgroundImage = "url(" + _self.tmp_img.src + ")";
	/* Chargement du script du jeu. */
	//visiware.preload.main.downloadJS();
    visiware.preload.main.downloadJSextends();
};

visiware.preload.Main.prototype.downloadJSextends = function(){
    // var DSLScript  = document.createElement("script");
    // /* Download le JS. */
    // DSLScript.src  = "./js/extends.js";
    // DSLScript.type = "text/javascript";
    // DSLScript.addEventListener( "load", function(){
        visiware.preload.main.downloadJS();
	// } );
    // DSLScript.addEventListener( "error", function(){
    //     console.log( "Script loading failed: " + DSLScript.src );
	// 	visiware.preload.main.errorMsg();
    // } );
    // document.head.appendChild(DSLScript);
};

/*
visiware.preload.Main.extendsDownloaded = function() {
    visiware.preload.main.downloadJS();
};
*/

/* Lance le chargement du script du jeu. */
visiware.preload.Main.prototype.downloadJS = function(){
	var DSLScript  = document.createElement("script");
	/* Download le JS. */
	var pathURL = window.location.pathname;
	var serchFor = "index_debug.html";
	if(pathURL.search(serchFor) === -1) {
        DSLScript.src  = "game.min.js";
	}
	else {
        DSLScript.src  = "./js/core.js";
	}
	DSLScript.type = "text/javascript";
	DSLScript.addEventListener( "load", visiware.preload.main.downloaded );
    DSLScript.addEventListener( "error", function(){
        console.log( "Script loading failed: " + DSLScript.src );
		visiware.preload.main.errorMsg();
    } );
	document.head.appendChild(DSLScript);
};

visiware.preload.Main.prototype.errorMsg = function(){
	//add error text on screen
	var msg = document.createElement("DIV");
	msg.innerHTML = "<br><br><br><br><br><br><p>Oops…</p><p>Something went wrong while loading the game.</p><p>Please try again later.</p>";
	msg.style.position = "fixed";
	msg.style.zIndex = "2147483645";
	msg.style.textAlign = "center";
	msg.style.backgroundColor = "#ad4c08";
	msg.style.color = "#ffffff";
	msg.style.width = "1280px";
	msg.style.height = "720px";
	msg.style.fontSize = "36px";
	document.body.appendChild(msg);
};

/* Callback au chargement du fichier de script du jeu. */
visiware.preload.Main.prototype.downloaded = function(){
	visiware.application.carrot2.main.onLoad();
};

visiware.preload.main = new visiware.preload.Main();
window.onload = visiware.preload.main.start;
